var https = require('https'),
	options = getHttpsOptions(process.env.TASKQ_API_KEY)

module.exports = {
	setApiKey: setApiKey,
	enqueue: enqueue
}

function setApiKey(newApiKey) {
	options.getHttpsOptions(newApiKey)
}

function enqueue(url, params, callback) {
	var body = buildBody(url, params)
	var data = ''
	var request = https.request(options, function (response) {
		if (response.statusCode >= 200 && response.statusCode <= 299) {
			callback()
			return
		}
		if (response >= 400) {
			response.on('data', function (chunk) {
				data += chunk
			})
			response.on('end', function () {
				callback(JSON.parse(data))
			})
			return
		}
		callback(response.statusCode)
	})
	request.on('error', function (e) {
		callback(e)
	})
	request.write(body)
	request.end()
}

function buildBody(url, params) {
	var json = {
		url: url
	}
	return JSON.stringify(json)
}

function getHttpsOptions(apiKey) {
	return {
		hostname: 'taskq.io',
		port: 443,
		path: '/api/v1/tasks',
		method: 'POST',
		headers: {
			'Content-Type': 'application/json',
			'Authorization': 'Bearer ' + apiKey
		}
	};
}